﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.IO.Ports;
using System.Threading;
using System.Management;
using System.Text.RegularExpressions;
using System.Runtime.InteropServices;
using AssemblyInfo;

namespace demo
{
    class Program
    {
        
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        /**解码数据回调函数**/
        public delegate int tx_scanner_decode_data_cb_fun(byte ucCodeType, [MarshalAs(UnmanagedType.LPArray, SizeConst = 8192)]byte[] pBuf, int uiBufLen);
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        /**通信接口连接状态0:断开,1:连接**/
        public delegate void tx_scanner_comm_state_cb_fun(byte ucState);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_init();

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_deinit();

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_uart_open(TS_UART_T tUart);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_uart_close();

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_get_version(byte[] pVer, byte ucVerLen);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_decode_data_fun_register(tx_scanner_decode_data_cb_fun fDataFun);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_comm_state_fun_register(tx_scanner_comm_state_cb_fun fStateFun);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_get_version_info(byte[] pVerInfo, int iVerInfoLen);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_get_all_product_info(byte[] pProInfo, int iProInfoLen);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_decode_start();

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_decode_stop();

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_no_time_decode_start();

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_set_trigger_mode(DB_TRIGGER_MODE_E eMode, byte isSaveParam);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_get_trigger_mode();

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_set_light_state(DB_LED_STATE_E eLedState, byte isSaveParam);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_get_light_state();

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_set_en_prefix(byte ucEnable, byte isSaveParam);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_get_en_prefix();

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_set_prefix(byte[] pData, byte ucDataLen, byte isSaveParam);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_get_prefix(byte[] pData, byte ucDataLen);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_set_en_suffix(byte ucEnable, byte isSaveParam);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_get_en_suffix();

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_set_suffix(byte[] pData, byte ucDataLen, byte isSaveParam);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_get_suffix(byte[] pData, byte ucDataLen);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_set_focus_state(DB_LED_STATE_E eLedState, byte isSaveParam);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_get_focus_state();

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_set_once_scan_time(int usTimeMs, byte isSaveParam);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_get_once_scan_time();

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_set_beep_volume(byte ucVol, byte isSaveParam);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_get_beep_volume();

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_set_heartbeat_type(DB_HEARTBEAT_TYPE_E eType, byte isSaveParam);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_get_heartbeat_type();

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_reset();

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_scan_sw(byte ucEnable);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_cmd_setcode_sw(byte ucEnable, byte isSaveParam);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_set_heartbeat_gap_time(int uiTimeMs, byte isSaveParam);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_get_heartbeat_gap_time();

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_set_heartbeat_wait_ack_time(int uiTimeMs, byte isSaveParam);

        [DllImport("..\\..\\..\\..\\..\\lib\\tx_windows_uart.dll", CallingConvention = CallingConvention.Cdecl)]
        private extern static int tx_scanner_get_heartbeat_wait_ack_time();

        static tx_scanner_decode_data_cb_fun s_fDecodeDataCb;
        static tx_scanner_comm_state_cb_fun s_fCommStateCb;

        static int s_uiDecodeCnt = 0;
        static int tx_scanner_sdk_decode_data_cb(byte ucCodeType, byte[] pBuf, int uiBufLen)
        {
            byte[] ucData = new byte[uiBufLen];
            string strData;
            int i;

            for(i=0; i<uiBufLen; i++)
            {
                ucData[i] = pBuf[i];
            }

            strData = System.Text.Encoding.Default.GetString(ucData, 0, uiBufLen);
            Console.WriteLine("[{0}][{1}]len:{2},data:{3}", ++s_uiDecodeCnt, ucCodeType, uiBufLen, strData);
            return 0;
        }

        static void tx_scanner_sdk_comm_state_cb_fun(byte ucState)
        {
            /**0:断开连接,1:连接**/
            Console.WriteLine("scanner comm state:{0}", ucState);
        }
        static void Main(string[] args)
        {
            int iRet;
            byte ucTemp1;
            byte ucTemp2;
            uint uiTemp3;
            byte uiLen = 0;
            byte[] ucVer = new byte[128];
            byte[] ucVerInfo = new byte[128];
            byte[] ucProInfo = new byte[512];
            byte[] cTemp = new byte[128];
            string cInput;
            string strTemp = null;
            int i = 0;
         
            TS_UART_T tUart = new TS_UART_T();

            iRet = tx_scanner_get_version(ucVer, (byte)ucVer.Length);
            if(iRet > 0)
                strTemp = System.Text.Encoding.Default.GetString(ucVer, 0, iRet);

            Console.WriteLine("windows c# uart demo ver:{0}", strTemp);

            /**注册解码数据回调函数**/
            s_fDecodeDataCb = tx_scanner_sdk_decode_data_cb;
            tx_scanner_decode_data_fun_register(s_fDecodeDataCb);

            /**注册设备连接状态回调函数**/
            s_fCommStateCb = tx_scanner_sdk_comm_state_cb_fun;
            tx_scanner_comm_state_fun_register(s_fCommStateCb);

            tUart.ucCom = new byte[32];
            tUart.ucCom[0] = (byte)'C';
            tUart.ucCom[1] = (byte)'O';
            tUart.ucCom[2] = (byte)'M';
            tUart.ucCom[3] = (byte)'3';
           
            Console.WriteLine("Enter the configuration parameters. By default, press Enter");
            Console.WriteLine("Please enter serial port number(default:COM3)");
            cInput = Console.ReadLine();
            if(!string.IsNullOrEmpty(cInput))
            {
                tUart.ucCom = new byte[32];
                for(i=0; i<cInput.Length; i++)
                {
                    tUart.ucCom[i] = (byte)cInput[i];
                }
            }

            tUart.eBaudrate = TS_UART_BAUDRATE_E.TS_BAUD_115200;
            Console.WriteLine("Please enter baud rate 0-13(default 10:115200)");
            Console.WriteLine("0:300");
            Console.WriteLine("1:600");
            Console.WriteLine("2:1200");
            Console.WriteLine("3:2400");
            Console.WriteLine("4:4800");
            Console.WriteLine("5:9600");
            Console.WriteLine("6:14400");
            Console.WriteLine("7:19200");
            Console.WriteLine("8:38400");
            Console.WriteLine("9:57600");
            Console.WriteLine("10:115200");
            Console.WriteLine("11:128000");
            Console.WriteLine("12:192000");
            Console.WriteLine("13:256000");
            cInput = Console.ReadLine();
            if(!string.IsNullOrEmpty(cInput) && !cInput.Contains(Environment.NewLine))
            {
                int baudRate;
                int.TryParse(cInput, out baudRate);
                tUart.eBaudrate = (TS_UART_BAUDRATE_E)baudRate;
            }

            tUart.eDataBits = TS_UART_DATA_BITS_E.TS_DATA_BITS_8;
            Console.WriteLine("Please enter data bits 0-3(default 3:8-bit),(0:5-bit)(1:6-bit)(2:7-bit)(3:8-bit)");
            cInput = Console.ReadLine();
            if(!string.IsNullOrEmpty(cInput) && !cInput.Contains(Environment.NewLine))
            {
                int dataBits;
                int.TryParse(cInput, out dataBits);
                tUart.eDataBits = (TS_UART_DATA_BITS_E)dataBits;
            }

            tUart.eStopBits = TS_UART_STOP_BITS_E.TS_STOP_BITS_1;
            Console.WriteLine("Please enter the stop bit 0-2(default 0:1-bit),(0:1-bit)(1:1.5-bit)(2:2-bit)");
            cInput = Console.ReadLine();
            if(!string.IsNullOrEmpty(cInput) && !cInput.Contains(Environment.NewLine))
            {
                int stopBits;
                int.TryParse(cInput, out stopBits);
                tUart.eStopBits = (TS_UART_STOP_BITS_E)stopBits;
            }

            tUart.eParityBits = TS_UART_PARITY_BITS_E.TS_PARITY_BITS_NONE;
            Console.WriteLine("Please enter a check digit 0-3(default 0:NONE),(0:NONE)(1:ODD)(2:EVEN)(3:MARK)(4:SPACE)");
            cInput = Console.ReadLine();
            if(!string.IsNullOrEmpty(cInput) && !cInput.Contains(Environment.NewLine))
            {
                int parityBits;
                int.TryParse(cInput, out parityBits);
                tUart.eParityBits = (TS_UART_PARITY_BITS_E)parityBits;
            }

            tUart.eFlowCtl = TS_UART_FLOW_CTL_E.TS_FW_NONE;
            Console.WriteLine("Please enter a control flow 0-2(default 0:FW_NONE)(0:FW_NONE,1:HARDWARE,2:SOFTWARE)");
            cInput = Console.ReadLine();
            if(!string.IsNullOrEmpty(cInput) && !cInput.Contains(Environment.NewLine)) ;
            {
                int flowCtl;
                int.TryParse(cInput, out flowCtl);
                tUart.eFlowCtl = (TS_UART_FLOW_CTL_E)flowCtl;
            }
            Console.WriteLine("******************************************************");

            /**初始化**/
            iRet = tx_scanner_init();
            if(iRet < 0)
	        {
		        Console.Write("tx_scanner_init fail!!!\r\n");
	        }

            iRet = tx_scanner_uart_open(tUart);
            if(iRet < 0)
	        {
		        Console.Write("tx_scanner_uart_open fail!!!\r\n");
	        }
           
            Console.Write("******************************************************\r\n");
            Console.Write("a:start decode\r\n");
            Console.Write("b:stop decode\r\n");
            Console.Write("c:no time decode start\r\n");
            Console.Write("d:get version info\r\n");
            Console.Write("e:get product info\r\n");
            Console.Write("f:set trigger mode; 0:LEVEL,1:PULSE,2:CONTINUOUS,3:AUTOSENS; save:0:no,1:yes.(eg:f01)\r\n");
            Console.Write("g:get trigger mode\r\n");
            Console.Write("h:set light LED; 0:working light,1:always off,2:always on; save:0:no,1:yes.(eg:h01)\r\n");
            Console.Write("i:get light LED\r\n");
            Console.Write("j:set prefix state; 0:OFF prefix,1:ON prefix; save:0:no,1:yes.(eg:j01)\r\n");
            Console.Write("k:get prefix state\r\n");
            Console.Write("l:set prefix parm;prefix by default:ABC(eg:l0)\r\n");
            Console.Write("m:get prefix\r\n");
            Console.Write("n:set suffix state; 0:OFF suffix,1:ON suffix; save:0:no,1:yes.(eg:n01)\r\n");
            Console.Write("o:get suffix state\r\n");
            Console.Write("p:set suffix parm;suffix by default:CBA(eg:p0)\r\n");
            Console.Write("r:get suffix\r\n");
            Console.Write("s:set light focus; 0:working light,1:always off,2:always on; save:0:no,1:yes.(eg:s01)\r\n");
            Console.Write("t:get light focus\r\n");
            Console.Write("u:set once scan time; from 0 to 65535ms; 0 indicates that there is no time limit; save:0:no,1:yes.(eg:u1000)+Enter+(eg:1)\r\n");
            Console.Write("v:get once scan time\r\n");
            Console.Write("w:set beep volume; from 0 to 100, 0: Silent; save:0:no,1:yes.(eg:w50)+Enter+(eg:1)\r\n");
            Console.Write("x:get beep volume\r\n");
            Console.Write("y:reset\r\n");
            Console.Write("z:scan switch; 0:OFF, 1:ON\r\n");
            Console.Write("1:setcode switch; 0:OFF, 1:ON; save:0:no,1:yes.(eg:101)\r\n");
            Console.Write("2:set heartbeat; 0:Default,1:No need for ACK,2:need for ACK; save:0:no,1:yes.(eg:201)\r\n");
            Console.Write("3:get heartbeat\r\n");
            Console.Write("4:set heartbeat gap time; from 0 to 2147483648ms; save:0:no,1:yes.(eg:41000)+Enter+(eg:1)\r\n");
            Console.Write("5:get heartbeat gap time\r\n");
            Console.Write("6:set heartbeat wait ack time; from 0 to 2147483648ms; save:0:no,1:yes.(eg:61000)+Enter+(eg:1)\r\n");
            Console.Write("7:get heartbeat wait ack time\r\n");
            Console.Write("q:quit\r\n");
            Console.Write("******************************************************\r\n");
            while(true)
            {
                switch(Console.ReadLine())
                {
                    case "A":
                    case "a":
                        iRet = tx_scanner_decode_start();
                        if(iRet < 0)
                            Console.Write("tx_scanner_decode_start fail!!!\r\n");
                        else
                            Console.Write("start\r\n");
                        break;

                    case "B":
                    case "b":
                        iRet = tx_scanner_decode_stop();
                        if(iRet < 0)
                            Console.Write("tx_scanner_decode_stop fail!!!\r\n");
                        else
                            Console.Write("stop\r\n");
                        break;

                    case "C":
                    case "c":
                        iRet = tx_scanner_no_time_decode_start();
                        if(iRet < 0)
                            Console.Write("tx_scanner_no_time_decode_start fail!!!\r\n");
                        else
                            Console.Write("no time start\r\n");
                        break;

                    case "D":
                    case "d":
                        iRet = tx_scanner_get_version_info(ucVerInfo, ucVerInfo.Length);
                        if(iRet < 0)
                        {
                            Console.Write("tx_scanner_get_version_info fail!!!\r\n");
                        }
                        else
                        {
                            strTemp = System.Text.Encoding.Default.GetString(ucVerInfo, 0, iRet);
                            Console.Write("{0}\r\n", strTemp);
                        }
                        break;

                    case "E":
                    case "e":
                        iRet = tx_scanner_get_all_product_info(ucProInfo, ucProInfo.Length);
                        if(iRet < 0)
                        {
                            Console.Write("tx_scanner_get_all_product_info fail!!!\r\n");
                        }
                        else
                        {
                            strTemp = System.Text.Encoding.Default.GetString(ucProInfo, 0, iRet);
                            Console.Write("{0}\r\n", strTemp);
                        }
                        break;

                    case "F":
			        case "f":
				        ucTemp1 = (byte)Console.Read();
                        ucTemp2 = (byte)Console.Read();

                        ucTemp1 -= (byte)'0'; 
                        ucTemp2 -= (byte)'0';
				        Console.Write("%d,%d\r\n", ucTemp1, ucTemp2);
				        iRet = tx_scanner_set_trigger_mode((DB_TRIGGER_MODE_E)ucTemp1, ucTemp2);
				        if(iRet < 0)
					        Console.Write("tx_scanner_set_trigger_mode fail!!!\r\n");
				        break;

			        case "G":
			        case "g":
				        iRet = tx_scanner_get_trigger_mode();
				        Console.Write("tx_scanner_get_trigger_mode:%d\r\n", iRet);
				        break;		

			        case "H":
			        case "h":
				        ucTemp1 = (byte)Console.Read();
                        ucTemp2 = (byte)Console.Read();

                        ucTemp1 -= (byte)'0'; 
                        ucTemp2 -= (byte)'0';
				        Console.Write("%d,%d\r\n", ucTemp1, ucTemp2);
				        iRet = tx_scanner_set_light_state((DB_LED_STATE_E)ucTemp1, ucTemp2);
				        if(iRet < 0)
					        Console.Write("ts_scanner_set_light_state fail!!!\r\n");
				        break;

			        case "I":
			        case "i":
				        iRet = tx_scanner_get_light_state();
				        Console.Write("ts_scanner_get_light_state:%d\r\n", iRet);
				        break;	

			        case "J":
			        case "j":
				        ucTemp1 = (byte)Console.Read();
                        ucTemp2 = (byte)Console.Read();

                        ucTemp1 -= (byte)'0'; 
                        ucTemp2 -= (byte)'0';
				        Console.Write("%d,%d\r\n", ucTemp1, ucTemp2);
				        iRet = tx_scanner_set_en_prefix(ucTemp1, ucTemp2);
				        if(iRet < 0)
					        Console.Write("tx_scanner_set_prefix_state fail!!!\r\n");
				        break;

			        case "K":
			        case "k":
				        iRet = tx_scanner_get_en_prefix();
				        Console.Write("tx_scanner_get_en_prefix:%d\r\n", iRet);
				        break;

			        case "L":
			        case "l":
				        {
					        ucTemp1 = (byte)Console.Read();
					        ucTemp1 -= (byte)'0';
					        Console.Write("%d\r\n", ucTemp1);
					        
                            string str = "ABC";
					        byte[] ucArr = Encoding.ASCII.GetBytes(str);
					        uiLen = (byte)str.Length;

					        iRet = tx_scanner_set_prefix(ucArr, uiLen,ucTemp1);
					        if(iRet < 0)
						        Console.Write("tx_scanner_set_prefix fail!!!\r\n");
					        break;
				        }
			        case "M":
			        case "m":
				        Array.Clear(cTemp, 0, cTemp.Length);
				        iRet = tx_scanner_get_prefix(cTemp, uiLen);
				        Console.Write("tx_scanner_get_prefix:%d\r\n", iRet);			
				        break;

			        case "N":
			        case "n":
				        ucTemp1 = (byte)Console.Read();
                        ucTemp2 = (byte)Console.Read();

                        ucTemp1 -= (byte)'0'; 
                        ucTemp2 -= (byte)'0';
				        Console.Write("%d,%d\r\n", ucTemp1, ucTemp2);
				        iRet = tx_scanner_set_en_suffix(ucTemp1, ucTemp2);
				        if(iRet < 0)
					        Console.Write("tx_scanner_set_en_suffix fail!!!\r\n");
				        break;

			        case "O":
			        case "o":
				        iRet = tx_scanner_get_en_suffix();
				        Console.Write("tx_scanner_get_en_suffix:%d\r\n", iRet);
				        break;

			        case "P":
			        case "p":
				        {
					        ucTemp1 = (byte)Console.Read();
					        ucTemp1 -= (byte)'0';
					        Console.Write("%d\r\n", ucTemp1);
					
					        string str = "CBA";
					        byte[] ucArr = Encoding.ASCII.GetBytes(str);
					        uiLen = (byte)str.Length;

					        iRet = tx_scanner_set_suffix(ucArr, uiLen,ucTemp1);
					        if(iRet < 0)
						        Console.Write("tx_scanner_set_suffix fail!!!\r\n");
					        break;
				        }

			        case "R":
			        case "r":
				        Array.Clear(cTemp, 0, cTemp.Length);
				        iRet = tx_scanner_get_suffix(cTemp, uiLen);
				        Console.Write("tx_scanner_get_suffix:%d\r\n", iRet);
				        break;
			
			        case "S":
			        case "s":
				        ucTemp1 = (byte)Console.Read();
                        ucTemp2 = (byte)Console.Read();

                        ucTemp1 -= (byte)'0'; 
                        ucTemp2 -= (byte)'0';
				        Console.Write("%d,%d\r\n", ucTemp1, ucTemp2);
				        iRet = tx_scanner_set_focus_state((DB_LED_STATE_E)ucTemp1, ucTemp2);
				        if(iRet < 0)
					        Console.Write("tx_scanner_set_focus_state fail!!!\r\n");
				        break;

			        case "T":
			        case "t":
				        iRet = tx_scanner_get_focus_state();
				        Console.Write("tx_scanner_get_focus_state:%d\r\n", iRet);
				        break;

			        case "U":
			        case "u":
                        cInput = Console.ReadLine();
				        uiTemp3 = uint.Parse(cInput);
				        ucTemp2 = (byte)Console.Read();
				        ucTemp2 -= (byte)'0';
				        Console.Write("%d,%d\r\n", uiTemp3, ucTemp2);
				        iRet = tx_scanner_set_once_scan_time((ushort)uiTemp3, ucTemp2);
				        if(iRet < 0)
					        Console.Write("tx_scanner_set_suffix_state fail!!!\r\n");
				        break;

			        case "V":
			        case "v":
				        iRet = tx_scanner_get_once_scan_time();
				        Console.Write("tx_scanner_get_once_scan_time:%d\r\n", iRet);
				        break;	

			        case "W":
			        case "w":
				        cInput = Console.ReadLine();
				        ucTemp1 = byte.Parse(cInput);
				        ucTemp2 = (byte)Console.Read();
				        ucTemp2 -= (byte)'0';
				        Console.Write("%d,%d\r\n", ucTemp1, ucTemp2);
				        iRet = tx_scanner_set_beep_volume(ucTemp1, ucTemp2);
				        if(iRet < 0)
					        Console.Write("tx_scanner_set_beep_volume fail!!!\r\n");
				        break;

			        case "X":
			        case "x":
				        iRet = tx_scanner_get_beep_volume();
				        Console.Write("tx_scanner_get_beep_volume:%d\r\n", iRet);
				        break;	

			        case "Y":
			        case "y":
				        iRet = tx_scanner_reset();
				        if(iRet < 0)
					        Console.Write("tx_scanner_reset fail!!!\r\n");
				        else
					        Console.Write("reset\r\n");				
				        break;

			        case "Z":
			        case "z":
				        ucTemp1 = (byte)Console.Read();
				        ucTemp1 -= (byte)'0';

				        Console.Write("%d\r\n", ucTemp1);
				        iRet = tx_scanner_scan_sw(ucTemp1);
				        if(iRet < 0)
					        Console.Write("tx_scanner_scan_sw fail!!!\r\n");
				        break;

			        case "1":
				        ucTemp1 = (byte)Console.Read();
                        ucTemp2 = (byte)Console.Read();

                        ucTemp1 -= (byte)'0'; 
                        ucTemp2 -= (byte)'0';
				        Console.Write("%d,%d\r\n", ucTemp1, ucTemp2);
				        iRet = tx_scanner_cmd_setcode_sw(ucTemp1, ucTemp2);
				        if(iRet < 0)
					        Console.Write("tx_scanner_cmd_setcode_sw fail!!!\r\n");
				        break;

			        case "2":
				        ucTemp1 = (byte)Console.Read();
                        ucTemp2 = (byte)Console.Read();

                        ucTemp1 -= (byte)'0'; 
                        ucTemp2 -= (byte)'0';
				        Console.Write("%d,%d\r\n", ucTemp1, ucTemp2);
				        iRet = tx_scanner_set_heartbeat_type((DB_HEARTBEAT_TYPE_E)ucTemp1, ucTemp2);
				        if(iRet < 0)
					        Console.Write("tx_scanner_set_heartbeat_type fail!!!\r\n");
				        break;

			        case "3":
				        iRet = tx_scanner_get_heartbeat_type();
				        Console.Write("tx_scanner_get_heartbeat_type:%d\r\n", iRet);
				        break;	

			        case "4":
				        cInput = Console.ReadLine();
				        uiTemp3 = uint.Parse(cInput);
				        ucTemp2 = (byte)Console.Read();
				        ucTemp2 -= (byte)'0';
				        iRet = tx_scanner_set_heartbeat_gap_time((int)uiTemp3, ucTemp2);
				        if(iRet < 0)
					        Console.Write("tx_scanner_set_heartbeat_gap_time fail!!!\r\n");
				        break;

			        case "5":
				        iRet = tx_scanner_get_heartbeat_gap_time();
				        Console.Write("tx_scanner_get_heartbeat_gap_time:%d\r\n", iRet);
				        break;	

			        case "6":
				        cInput = Console.ReadLine();
				        uiTemp3 = uint.Parse(cInput);
				        ucTemp2 = (byte)Console.Read();
				        ucTemp2 -= (byte)'0';
				        iRet = tx_scanner_set_heartbeat_wait_ack_time((int)uiTemp3, ucTemp2);
				        if(iRet < 0)
					        Console.Write("tx_scanner_set_heartbeat_wait_ack_time fail!!!\r\n");
				        break;

			        case "7":
				        iRet = tx_scanner_get_heartbeat_wait_ack_time();
				        Console.Write("tx_scanner_get_heartbeat_wait_ack_time:%d\r\n", iRet);
				        break;	

                    case "Q":
                    case "q":
                        return;
                        break;

                    default:
                        break;
                }
            }
        }
    }
}
