﻿using System.Reflection;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

// 有关程序集的一般信息由以下
// 控制。更改这些特性值可修改
// 与程序集关联的信息。
[assembly: AssemblyTitle("demo")]
[assembly: AssemblyDescription("")]
[assembly: AssemblyConfiguration("")]
[assembly: AssemblyCompany("")]
[assembly: AssemblyProduct("demo")]
[assembly: AssemblyCopyright("Copyright ©  2023")]
[assembly: AssemblyTrademark("")]
[assembly: AssemblyCulture("")]

//将 ComVisible 设置为 false 将使此程序集中的类型
//对 COM 组件不可见。  如果需要从 COM 访问此程序集中的类型，
//请将此类型的 ComVisible 特性设置为 true。
[assembly: ComVisible(false)]

// 如果此项目向 COM 公开，则下列 GUID 用于类型库的 ID
[assembly: Guid("05dd1f53-5fa8-4119-ad5f-e528ca61b906")]

// 程序集的版本信息由下列四个值组成: 
//
//      主版本
//      次版本
//      生成号
//      修订号
//
//可以指定所有这些值，也可以使用“生成号”和“修订号”的默认值，
// 方法是按如下所示使用“*”: :
// [assembly: AssemblyVersion("1.0.*")]
[assembly: AssemblyVersion("1.0.0.0")]
[assembly: AssemblyFileVersion("1.0.0.0")]

namespace AssemblyInfo
{
    /**解码触发方式**/
    public enum DB_TRIGGER_MODE_E
    {
        DB_TRIGGER_M_LEVEL = 0x00,  /**00[被动](电平)按键保持**/    //默认
        DB_TRIGGER_M_PULSE,         /**01[被动](脉冲)单次按键触发模式**/
        DB_TRIGGER_M_CONTINUOUS,    /**02[主动]连续模式**/
        DB_TRIGGER_M_AUTOSENS,      /**03[主动]自动感应模式**/
    }

    /**LED灯的状态**/
    public enum DB_LED_STATE_E
    {
        DB_LED_S_NORMAL = 0x00,     /**正常读码的时候亮**/
        DB_LED_S_ALWAYS_OFF,        /**一直关闭**/
        DB_LED_S_ALWAYS_ON,         /**一直开启**/
    }

    /**串口波特率**/
    public enum TS_UART_BAUDRATE_E
    {
        TS_BAUD_300 = 0x00,
        TS_BAUD_600,
        TS_BAUD_1200,
        TS_BAUD_2400,
        TS_BAUD_4800,
        TS_BAUD_9600,
        TS_BAUD_14400,
        TS_BAUD_19200,
        TS_BAUD_38400,
        TS_BAUD_57600,
        TS_BAUD_115200, /**默认**/
        TS_BAUD_128000,
        TS_BAUD_192000,
        TS_BAUD_256000,

        TS_BAUD_MAX,
    }

    /**串口数据位**/
    public enum TS_UART_DATA_BITS_E
    {
        TS_DATA_BITS_5 = 0x00,
        TS_DATA_BITS_6,
        TS_DATA_BITS_7,
        TS_DATA_BITS_8, /**默认**/

        TS_DATA_BITS_MAX,
    }

    /**串口停止位**/
    public enum TS_UART_STOP_BITS_E
    {
        TS_STOP_BITS_1 = 0x00, /**默认**/
        TS_STOP_BITS_1_5,   /**数据位必须是5位**/
        TS_STOP_BITS_2,     /**数据位必须是6,7,8位**/

        TS_STOP_BITS_MAX,
    }

    /**串口校验位**/
    public enum TS_UART_PARITY_BITS_E
    {
        TS_PARITY_BITS_NONE = 0x00, /**默认**/
        TS_PARITY_BITS_ODD,
        TS_PARITY_BITS_EVEN,
        TS_PARITY_BITS_MARK,
        TS_PARITY_BITS_SPACE,

        TS_PARITY_BITS_MAX,
    }

    /**串口流控制**/
    public enum TS_UART_FLOW_CTL_E
    {
        TS_FW_NONE = 0x00, /**默认**/
        TS_FW_HARDWARE,
        TS_FW_SOFTWARE,

        TS_FW_MAX,
    }

    // 串口配置
    [StructLayout(LayoutKind.Sequential, Pack = 1)]
   public struct TS_UART_T
    {
        [MarshalAs(UnmanagedType.ByValArray, SizeConst = 32)]
        public byte[] ucCom; /**串口号**/
        public TS_UART_BAUDRATE_E eBaudrate;   /**波特率**/
        public TS_UART_DATA_BITS_E eDataBits;  /**数据位**/
        public TS_UART_STOP_BITS_E eStopBits;  /**停止位**/
        public TS_UART_PARITY_BITS_E eParityBits;/**校验位**/
        public TS_UART_FLOW_CTL_E eFlowCtl;    /**流控制**/
       
    }



    // 心跳类型
    public enum DB_HEARTBEAT_TYPE_E
    {
        DB_HEARTBEAT_T_DISABLE = 0x00,
        DB_HEARTBEAT_T_NOT_ACK,
        DB_HEARTBEAT_T_NEED_ACK,
    }
}